import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
public class Engine extends Canvas{
    Thread t;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    int height=0;
    int width=0;
    int key=0;
    Doubleg x;
    Doubleg y;
    Doubleg z;
    Doubleg vx;
    Doubleg vy;
    Doubleg vz;
    Doubleg tmp1;
    Doubleg tmp2;
    Doubleg winkel;
    Vektor veci;
    Vektor kv;
    Poladd pogy;
    Polygon pol;
    Vektor point;
    boolean painted=false;
    PaintGroup[]pgs=new PaintGroup[0];
    public Engine(){
        img=Image.createImage(800,600);
        h=img.getGraphics();
        height=getHeight();
        width=getWidth();
        x=new Doubleg(0);
        y=new Doubleg(0);
        z=new Doubleg(0);
        vx=new Doubleg(0);
        vy=new Doubleg(0);
        vz=new Doubleg(0);
        tmp1=new Doubleg(0);
        tmp2=new Doubleg(0);
        winkel=new Doubleg(0);
        veci=new Vektor(new Doubleg(0),new Doubleg(0),new Doubleg(0));
        kv=new Vektor(new Doubleg(0),new Doubleg(0),new Doubleg(0));
        pogy=new Poladd();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
//        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void reset(){
        Polygon cur=start;
        while(cur!=null){
            cur.reset();
            cur=cur.next;
        }
    }
    public synchronized void save(){
        Polygon cur=start;
        while(cur!=null){
            cur.save();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(Doubleg a,Doubleg b,Doubleg c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        pg.next=null;
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        Doubleg middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf.l<middlevalue.l){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf.l>middlevalue.l){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized void getCoord(Vektor res,Vektor v){
        x.l=v.x.l;
        y.l=v.y.l;
        z.l=v.z.l;
        if(x.l==0){
            res.x.l=-1;
            res.y.l=0;
            res.z.l=0;
            return;
        }
        tmp1.l=y.l*1000/x.l;
        tmp2.l=6*width/2*1000*1000/Sin.PI.l;
        Tan.atan(vx,tmp1);
        vx.l=vx.l*tmp2.l/1000;
        tmp1.l=z.l*1000/x.l;
        tmp2.l=6*width/2*1000*1000/Sin.PI.l;
        Tan.atan(vy,tmp1);
        vy.l=vy.l*tmp2.l/1000;
        vz.l=x.l;
        res.x.l=vx.l;
        res.y.l=vy.l;
        res.z.l=vz.l;
    }
    protected void keyPressed(int k){
        key=k;
    }
    public int getKey(){
        int r=key;
        key=0;
        return r;
    }
    public synchronized void paint(Graphics g){
        if(first){
            first=false;
            return;
        }
        if(!ison){
            if(img!=null){
                g.drawImage(img,0,0,0);
                return;
            }
        }
        h.setColor(255,255,255);
        h.fillRect(0,0,800,600);
//System.gc();
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        if(pgs.length!=count){
            pgs=new PaintGroup[count];
        }
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        for(int i=pgs.length-1;i>=0;i--){
            pol=pgs[i].start;
            while(pol!=null){
                point=pol.start;
                if(pol.kugel){
                    getCoord(kv,point);
                    if(kv.z.l>0){
                        tmp1.l=pol.radius.l*1000/pgs[i].entf.l;
                        Tan.atan(winkel,tmp1);
                        int len=(int)(winkel.l*width*6/Sin.PI.l);
                        setColor(h,pol.col);
                        if(!inverse){
                            h.fillArc(width/2-(len/2)+((int)kv.x.getInt()),height/2-(len/2)-((int)kv.y.getInt()),len,len,0,360);
                        }
                        else{
                            h.fillArc(width/2-(len/2)+((int)kv.x.getInt()),height/2+(len/2)-((int)kv.y.getInt()),len,len,0,360);
                        }
                    }
                }
                else{
                    pogy.reset();
                    boolean seen=true;
                    while(point!=null){
                        getCoord(veci,point);
                        if(veci.z.l<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x.getInt()),(int)(height/2-veci.y.getInt()));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x.getInt()),(int)(height/2+veci.y.getInt()));
                        }
                        point=point.next;
                    }
                    if(seen){
                        setColor(h,pol.col);
                        h.fillTriangle(pogy.x1,pogy.y1,pogy.x2,pogy.y2,pogy.x3,pogy.y3);
                        if(pol.col.r!=pol.rcol.r||pol.col.g!=pol.rcol.g||pol.col.b!=pol.rcol.b){
                            setColor(h,pol.rcol);
                            h.drawLine(pogy.x1,pogy.y1,pogy.x2,pogy.y2);
                            h.drawLine(pogy.x2,pogy.y2,pogy.x3,pogy.y3);
                            h.drawLine(pogy.x3,pogy.y3,pogy.x1,pogy.y1);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        g.drawImage(img,0,0,0);
        paintg=g;
        painted=true;
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
    public synchronized void setColor(Graphics h,Color col){
        h.setColor(col.r,col.g,col.b);
    }
}
class Poladd{
    int x1=0;
    int y1=0;
    int x2=0;
    int y2=0;
    int x3=0;
    int y3=0;
    int c=0;
    public Poladd(){
    }
    public void reset(){
        x1=0;
        y1=0;
        x2=0;
        y2=0;
        x3=0;
        y3=0;
        c=0;
    }
    public void addPoint(int x,int y){
        if(c==0){
            x1=x;
            y1=y;
        }
        if(c==1){
            x2=x;
            y2=y;
        }
        if(c==2){
            x3=x;
            y3=y;
        }
        c++;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    Doubleg entf=new Doubleg(0);
    Vektor sum;
    public PaintGroup(){
        sum=new Vektor(new Doubleg(0),new Doubleg(0),new Doubleg(0));
    }
    public void getEntf(){
        entf(entf);
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        p.gnext=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public void entf(Doubleg ret){
        int count=0;
        Polygon cur=start;
        sum.x.l=0;
        sum.y.l=0;
        sum.z.l=0;
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getX(),cur2.getY(),cur2.getZ());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        sum.x.l=sum.x.l/count;
        sum.y.l=sum.y.l/count;
        sum.z.l=sum.z.l/count;
        sum.entf(ret);
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void add(Polygon p){
        p.grnext=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void rotUp(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(Doubleg w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(Doubleg a,Doubleg b,Doubleg c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,Doubleg radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    Doubleg radius=new Doubleg(0);
    boolean processed=false;
    Doubleg entf=new Doubleg(0);
    Vektor sum;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
        sum=new Vektor(new Doubleg(0),new Doubleg(0),new Doubleg(0));
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void reset(){
        Vektor cur=start;
        while(cur!=null){
            cur.reset();
            cur=cur.next;
        }
    }
    public void save(){
        Vektor cur=start;
        while(cur!=null){
            cur.save();
            cur=cur.next;
        }
    }
    public void rotUp(Doubleg w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(Doubleg w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public void entf(Doubleg ret){
        int count=0;
        Vektor cur=start;
        sum.x.l=0;
        sum.y.l=0;
        sum.z.l=0;
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        sum.x.l=sum.x.l/count;
        sum.y.l=sum.y.l/count;
        sum.z.l=sum.z.l/count;
        sum.entf(ret);
    }
    public void transform(Doubleg a,Doubleg b,Doubleg c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class Vektor{
    Doubleg x,y,z;
    Doubleg xtra;
    Vektor next;
    Doubleg sx;
    Doubleg sy;
    Doubleg sz;
    public Vektor(Doubleg x,Doubleg y,Doubleg z){
        this.x=x;
        this.y=y;
        this.z=z;
        sx=new Doubleg(0);
        sy=new Doubleg(0);
        sz=new Doubleg(0);
    }
    public void print(){
//        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public Doubleg getX(){
        return x;
    }
    public Doubleg getY(){
        return y;
    }
    public Doubleg getZ(){
        return z;
    }
    public Doubleg getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x.cloneo(),y.cloneo(),z.cloneo());
        if(xtra!=null)cl.xtra=xtra.cloneo();
        return cl;
    }
    public void transform(Doubleg a,Doubleg b,Doubleg c){
        x.l=x.l+a.l;
        y.l=y.l+b.l;
        z.l=z.l+c.l;
    }
    public void setCoord(int coord,Doubleg a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==3)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        Doubleg temp=null;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public void entf(Doubleg res){
        Doubleg tmp=new Doubleg(0);
        tmp.l=(x.l*x.l/1000)+(y.l*y.l/1000)+(z.l*z.l/1000);
        if(tmp.l==0){
            res.l=0;
        }
        else{
            Doubleg.sqrt(res,tmp);
        }
    }
    public void rotLeft(Doubleg w){
        Doubleg win=new Doubleg(0);
        Doubleg tmp=new Doubleg(0);
        Doubleg len=new Doubleg(0);
        win.l=0;
        if(x.l==0){
            if(y.l>0)win.l=Sin.PI.l/2;
            else win.l=Sin.PI.l/(-2);
        }
        else{
            tmp.l=y.l*1000/x.l;
            Tan.atan(win,tmp);
        }
        if(x.l<0)win.l=win.l+Sin.PI.l;
        tmp.l=x.l*x.l/1000+y.l*y.l/1000;
        if(tmp.l==0){
            len.l=0;
        }
        else{
            Doubleg.sqrt(len,tmp);
        }
        win.l=win.l+w.l;
        Cos.cos(x,win);
        Sin.sin(y,win);
        x.l=x.l*len.l/1000;
        y.l=y.l*len.l/1000;
    }
    public void reset(){
        x.l=sx.l;
        y.l=sy.l;
        z.l=sz.l;
    }
    public void save(){
        sx.l=x.l;
        sy.l=y.l;
        sz.l=z.l;
    }
    public void rotUp(Doubleg w){
        Doubleg win=new Doubleg(0);
        Doubleg tmp=new Doubleg(0);
        Doubleg len=new Doubleg(0);
        win.l=0;
        if(x.l==0){
            if(z.l>0)win.l=Sin.PI.l/2;
            else win.l=Sin.PI.l/(-2);
        }
        else{
            tmp.l=z.l*1000/x.l;
            Tan.atan(win,tmp);
        }
        if(x.l<0)win.l=win.l+Sin.PI.l;
        tmp.l=x.l*x.l/1000+z.l*z.l/1000;
        if(tmp.l==0){
            len.l=0;
        }
        else{
            Doubleg.sqrt(len,tmp);
        }
        win.l=win.l+w.l;
        Cos.cos(x,win);
        Sin.sin(z,win);
        x.l=x.l*len.l/1000;
        z.l=z.l*len.l/1000;
    }
}
class Color{
    int r=0;
    int g=0;
    int b=0;
    public Color(int r,int g,int b){
        this.r=r;
        this.g=g;
        this.b=b;
    }
}
